﻿B4J=true
Group=BANano
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
#IgnoreWarnings:12
Sub Class_Globals
	Private BOVue As BANanoObject
	Private BANAno As BANano  'ignore
	Private methods As Map
	Private data As Map
	Private body As BANanoElement
End Sub

'initialize view
Public Sub Initialize As BANanoElement
	BOVue.Initialize("Vue")
	'empty the body of the page
	body = BANAno.GetElement("#body")
	body.empty
	'add an empty div
	Dim app As BANanoElement = body.Append($"<div id="app"></div>"$).Get("#app")
	methods.Initialize
	data.Initialize 
	Return app 
End Sub

'check if we have state
Sub StateExists(stateName As String) As Boolean
	Return data.ContainsKey(stateName)
End Sub

'set the font family
Sub SetFontFamily(ff As Object)
	body.SetStyle(BANAno.ToJson(CreateMap("font-family": ff)))
End Sub

'use a component module
Sub Use(bo As BANanoObject)
	BOVue.RunMethod("use", bo)
End Sub

'render the ux
Sub UX()
	Dim opt As Map = CreateMap()
	opt.Put("el", "#app")
	If data.Size > 0 Then
		opt.put("data", data)
	End If
	If methods.Size > 0 Then
		opt.Put("methods", methods)
	End If
	BOVue.Initialize2("Vue", opt)
	'get the state
	Dim dKey As String = "$" & "data"
	data = BOVue.GetField(dKey).Result
End Sub

'add a method
Sub SetMethod(methodName As String, cb As BANanoObject) As BANanoVue
	methods.Put(methodName, cb)
	Return Me
End Sub

'set default states
Sub SetDefaultState(m As Map) As BANanoVue
	For Each k As String In m.Keys
		Dim v As Object = m.Get(k)
		data.Put(k, v)
	Next
	Return Me
End Sub

'set the state
Sub SetState(m As Map) As BANanoVue
	'get the current state
	'Dim dKey As String = "$" & "data"
	'Dim data As Map = BOVue.GetField(dKey).Result
	For Each k As String In m.Keys
		Dim v As Object = m.Get(k)
		If data.ContainsKey(k) Then
			data.Put(k, v)
		Else
			Log("First set the v-model for " & k)
		End If
	Next
	Return Me	
End Sub

'get the state
Sub GetState(k As String) As Object
	If data.ContainsKey(k) Then
		'Dim dKey As String = "$" & "data"
		'Dim data As Map = BOVue.GetField(dKey).Result
		Dim out As Object = data.Get(k)
		Return out
	Else
		Log("First set the v-model for " & k)
		Return ""
	End If	
End Sub