﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
#IgnoreWarnings:12
Sub Class_Globals
	Public LI As VueHTML
	Public ID As String
	Private vue As BANanoVue
	Private BANano As BANano  'ignore
	Private ds As Object
	Private recName As String
End Sub

'initialize the button
Public Sub Initialize(v As BANanoVue, sid As String) As VueLI
	ID = sid.tolowercase
	LI.Initialize(ID)
	LI.SetTag("li")
	vue = v
	ds = ""
	recName = "row"
	Return Me
End Sub

'set the data source for the list
Sub SetData(dsx As Object) As VueLI
	If vue.StateExists(dsx) = False Then
		Log("The data source state has not been registered, register it first, " & dsx)
		Return Me
	End If
	ds = dsx
	SetFor(recName)
	SetKey("id")
	SetValue("value")
	Return Me
End Sub

'set onclick event
Sub SetOnClick(module As Object, methodName As String) As VueLI
	methodName = methodName.tolowercase
	Dim e As BANanoEvent
	Dim cb As BANanoObject = BANano.CallBack(module, methodName, e)
	'set the directive
	LI.SetAttr("v-on:click", methodName)
	'add to methods
	vue.SetMethod(methodName, cb)
	Return Me
End Sub

'set for
private Sub SetFor(itemName As Object) As VueLI
	Dim sline As String = $"${itemName} in ${ds}"$
	LI.SetAttr("v-for", sline)
	Return Me
End Sub

'set id
private Sub SetKey(l As Object) As VueLI
	If ds = "" Then
		Log("VueLI.SetKey, you need to run VueLI.SetData first before you set key!")
		Return Me
	End If
	Dim keyName As String = $"${recName}.${l}"$
	LI.SetAttr("v-bind:key", keyName)
	Return Me
End Sub

'set value
private Sub SetValue(l As Object) As VueLI
	If ds = "" Then
		Log("VueLI.SetValue, you need to run VueLI.SetData first before you set value!")
		Return Me
	End If
	Dim valueName As String = $"${recName}.${l}"$
	Dim txt As String = $"{{ ${valueName} }}"$
	LI.SetText(txt)
	Return Me
End Sub

'set template
Sub SetTemplate(tmp As Object) As VueLI
	LI.Clear
	LI.SetText(tmp)
	Return Me
End Sub

'get component
Sub ToString As String
	Return LI.html
End Sub

'render
Sub Render(parent As String)
	BANano.GetElement(parent).Append(ToString)
End Sub