﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
#IgnoreWarnings:12
Sub Class_Globals
	Public Paragraph As VueHTML
	Public ID As String
	Private vue As BANanoVue
	Private BANano As BANano  'ignore
End Sub

'initialize the button
Public Sub Initialize(v As BANanoVue, sid As String) As VueParagraph
	ID = sid.tolowercase
	Paragraph.Initialize(ID)
	Paragraph.SetTag("p")
	vue = v
	Return Me
End Sub

'set if condition shows only when condition is met
Sub SetIf(state As String, operator As String, value As Object) As VueParagraph
	Dim cond As String = $"${state} ${operator} ${value}"$
	Paragraph.SetAttr("v-if", cond)
	Return Me
End Sub

'set show to toggle the display
Sub SetShow(state As String, operator As String, value As Object) As VueParagraph
	Dim cond As String = $"${state} ${operator} ${value}"$
	Paragraph.SetAttr("v-show", cond)
	Return Me
End Sub

'set template
Sub SetTemplate(tmp As Object) As VueParagraph
	Paragraph.Clear
	Paragraph.SetText(tmp)
	Return Me
End Sub


'set onclick event
Sub SetOnClick(module As Object, methodName As String) As VueParagraph
	methodName = methodName.tolowercase
	Dim e As BANanoEvent
	Dim cb As BANanoObject = BANano.CallBack(module, methodName, e)
	'set the directive
	Paragraph.SetAttr("v-on:click", methodName)
	'add to methods
	vue.SetMethod(methodName, cb)
	Return Me
End Sub

'set label
Sub SetText(l As Object) As VueParagraph
	Paragraph.SetText(l)
	Return Me
End Sub

'get component
Sub ToString As String
	Return Paragraph.html
End Sub

'render
Sub Render(parent As String)
	BANano.GetElement(parent).Append(ToString)
End Sub