﻿B4J=true
Group=Pages
ModulesStructureVersion=1
Type=StaticCode
Version=7.8
@EndOfDesignText@
'Static code module
#IgnoreWarnings:12
Sub Process_Globals
	Public Vue As BANanoVue
	Private BANano As BANano  'ignore
	Private app As BANanoElement
End Sub

Sub Init
	'initialize vue, this clears the body and adds an empty div identified with app.
	app = Vue.Initialize
	'set the font family
	Vue.SetFontFamily($"'Ubuntu', sans-serif"$)
	'set the default state
	Dim state As Map = CreateMap()
	state.Put("greeting", "Hello World!")
	state.Put("user", "The Mash")
	state.Put("city","East London")
	state.Put("image", "./assets/benz.jpg")
	state.Put("desc", "Mercerdes Benz East London Plant")
	Vue.SetDefaultState(state)
	
	'let's update the app div
	app.Append($"<h2>{{ greeting }}</h2>"$)
	'
	Dim p1 As VueParagraph
	p1.Initialize(Vue, "p1").SetText($"by {{ user }} who lives in {{ city }}"$).SetIf("city", "===", "'East London'").Render("#app")
	'
	Dim p2 As VueParagraph
	p2.Initialize(Vue, "p2").SetText($"by {{ user }} who wishes to visit {{ city }}"$).SetShow("city", "===", "'Jerusalem'").Render("#app")
	'
	Dim img As VueImage
	img.Initialize(Vue, "mbel").SetSrc("image").SetAlt("desc").Render("#app")
	'
	Dim desc As VueParagraph
	desc.Initialize(Vue, "").SetText("{{ desc }}").Render("#app")
	'
	Dim btn1 As VueButton
	btn1.Initialize(Vue, "btn1").SetOnClick(Me, "changeGreeting").SetText("Change Greeting").Render("#app") 
	'
	'
	Dim desc1 As VueParagraph
	desc1.Initialize(Vue, "").SetText("You can change the image by clicking below").Render("#app")
	
	Dim btn2 As VueButton
	btn2.Initialize(Vue, "btn2").SetOnClick(Me, "changeCity").SetText("Change City").Render("#app")
		
	'execute the DOM rendering
	Vue.ux
End Sub

Sub changeGreeting(e As BANanoEvent)
	'get current greeting
	Dim greeting As String = Vue.GetState("greeting")
	'toggle the state
	greeting = BANano.IIf(greeting = "Hello World!", "What's Up", "Hello World!")
	'update the state
	Vue.SetState(CreateMap("greeting":greeting))
End Sub

Sub changeCity(e As BANanoEvent)
	'get the current city
	Dim city As String = Vue.GetState("city")
	Select Case city
	Case "East London"
		Dim opt As Map = CreateMap()
		opt.Put("city", "Jerusalem")
		opt.Put("image", "./assets/israel.jpg")
		opt.Put("desc", "The Jerusalem")
		Vue.SetState(opt)
	Case Else
		Dim opt As Map = CreateMap()
		opt.Put("city", "East London")
		opt.Put("image", "./assets/icc.jpg")
		opt.Put("desc", "International Convention Centre")
		Vue.SetState(opt)
	End Select
End Sub